import sys, os
sys.path.append(os.pardir)

import numpy as np
import matplotlib.pyplot as plt
from dataset.mnist import load_mnist

# Load MNIST dataset
(x_train, t_train), (x_test, t_test) = load_mnist(normalize=True, one_hot_label=False)

# Sample Image
X=x_train[0]#5
X=X.reshape(28,28)

# Compute mean
mu = np.mean(X,axis=0)
X_tilde = X-mu

# Compute covariance
N=np.size(X,0)
C=np.dot(X_tilde,X_tilde.T)/N

# PCA
U,Sigma,V=np.linalg.svd(X_tilde)

# Image compression
num_Uk=12
Uk=U[:,0]

for k in range(1,num_Uk):
    Uk=np.column_stack((Uk,U[:,k].T))

# Projected Image data
y = np.dot(Uk.T,X_tilde)

# Reconstruction from the projected data
Xk = np.dot(Uk,y)+mu

fig = plt.figure()
ax1 = fig.add_subplot(1,2,1)
ax1.imshow(X ,cmap='gray')
ax1.set_title('Original image')
ax1.axis("off")
ax2 = fig.add_subplot(1,2,2)
ax2.imshow(Xk,cmap='gray')
ax2.set_title('Compressed image')
ax2.axis("off")
plt.show()